<template>
	<el-form ref="formRef" @submit="handleSubmit">
		<el-form-item v-if="formType === 'TOKEN'" :label="label">
			<el-input v-model="token" />
		</el-form-item>
		<div v-else>
			<el-form-item label="Username">
				<el-input v-model="username" />
			</el-form-item>
			<el-form-item label="Password">
				<el-input type="password" v-model="password" />
			</el-form-item>
		</div>
		<el-alert v-if="fullname" type="success">Successfully logged as '{{ fullname }}'</el-alert>
		<el-alert v-if="error" type="error">{{ error }}</el-alert>
		<br />
		<el-form-item>
			<el-button type="primary" native-type="submit" @click="submit">Sing in</el-button>
		</el-form-item>
	</el-form>
</template>

<script lang="ts" setup>
import { ElForm, ElFormItem, ElButton, ElInput, ElAlert, ElLoading, ILoadingInstance } from "element-plus";
import { computed, onMounted, ref, ComponentPublicInstance } from "vue-demi";
import { ApiKind, TE } from "../../lib/types";
import { pipe, T } from "../../lib/utils";
import { clickupClient } from "../ts/apis";
import { apiResolveOrAlert, authClickApi, getAuthToken, getAuthUserInfo, getClickUserInfo, getUserInfo, loadAuthInfo, notify, resolveOrAlertMessage, saveAuthToken, uiSingleAlert, updateAuthInfo } from "../ts/utils";

const props = defineProps<{
	kind: ApiKind;
}>();

const emits = defineEmits<{
	(e: "logged", success: boolean): void;
}>();



const formType = computed(() => props.kind === "Click" ? "AUTH" : "TOKEN");

const token = ref<string>('');
const label = computed(() => `${props.kind} token`);
const username = ref<string>('');
const password = ref<string>('');
const fullname = ref<string>();
const error = ref<string>();
const loading = ref<boolean>(false);
const formRef = ref<ComponentPublicInstance>();

let loadingService: ILoadingInstance | null = null;

onMounted(() => {
	const { kind } = props;
	console.log(formRef.value);
	pipe(
		getAuthToken(kind),
		T.map(x => token.value = x || '')
	)();

	if (kind === "Click") {
		pipe(
			getAuthUserInfo(kind),
			TE.map(user => {
				username.value = user.username || '';
			})
		)();
	}
});

function handleSubmit(e: Event) {
	e.preventDefault();
}

async function submit(): Promise<void> {
	showLoading();
	return savePromise().finally(() => closeLoading());
}

async function savePromise(): Promise<void> {
	switch (formType.value) {
		case "TOKEN":
			return testAuthToken(token.value);

		case "AUTH":
			return authenticate(username.value, password.value);
	}

}

async function testAuthToken(tkn: string): Promise<void> {
	const kind = props.kind;
	if (!await saveAuthToken(kind, tkn)()) {
		notifyError("Token not saved.");
		return;
	}

	return pipe(
		loadAuthInfo(kind),
		TE.mapLeft(x => x.statusCode === 401 ? 'Authentication failed.' : "Load user info failed."),
		TE.chain(user => {
			return updateAuthInfo(kind, (u) => {
				return {
					...u,
					...user
				}
			});
		}),
		TE.match(
			(err) => notifyError(err),
			(u) => notifyAuthenticated(kind, u.fullname)
		)
	)();
}

async function authenticate(email: string, pw: string): Promise<void> {
	return pipe(
		clickupClient.login({
			email,
			password: pw,
		}),
		TE.mapLeft(x => x.clickError?.err || x.message),
		TE.chain(result => {
			return pipe(
				authClickApi(),
				TE.map(() => result)
			);
		}),
		TE.chain(user => {
			return updateAuthInfo("Click", (u) => {
				return {
					...u,
					id: user.user.id,
					username: user.user.email,
					fullname: user.user.username,
					refreshToken: user.refresh_token,
					webToken: user.token,
				}
			});
		}),
		TE.match(
			err => notifyError(err),
			user => notifyAuthenticated("Click", user.fullname)
		)
	)();
}

function showLoading() {
	closeLoading();
	loading.value = true;
	loadingService = ElLoading.service({
		target: formRef.value?.$el || undefined,
		fullscreen: false,
		lock: true,
	});
}

function closeLoading() {
	loading.value = false;
	if (loadingService) {
		loadingService.close();
		loadingService = null;
	}
}

function notifyError(msg: string) {
	fullname.value = undefined;
	error.value = msg;
	emits("logged", false);
}

function notifyAuthenticated(kind: ApiKind, name: string) {
	// notify(`Authenticate to ${kind} API as user '${name}' was successfully.`, "success");
	fullname.value = name;
	error.value = undefined;
	emits("logged", true);
}

</script>